# Compiler Design Lab

### List of Experiments

<ol>
  <li> Design and implement a lexical analyzer for given language using C. The lexical analyzer should ignore redundant spaces, tabs and newlines. </li>   
  <li>Implementation of Lexical Analyzer using Lex Tool.</li>
  <li>Generate YACC specification for a few syntactic categories.</li>      
    <ol style="list-style-type:lower-alpha">
      <li>Program to recognize a valid arithmetic expression that uses operator +, –, * and /.</li>
      <li>Implementation of Calculator using LEX and YACC.</li>
      <li>Convert the BNF rules into YACC form and write code to generate abstract syntax tree.</li>
    </ol>
  <li>Write program to find ε – closure of all states of any given NFA with ε transition</li>
  <li>Write program to convert NFA with ε transition to NFA without ε transition.</li>
  <li>Write program to convert NFA to DFA.</li>
  <li>Write program to minimize any given DFA.</li>
  <li>Develop an operator precedence parser for a given language.</li>
  <li>Write program to Simulate First and Follow of any given grammar.</li>
  <li>Construct a recursive descent parser for an expression.</li>
  <li>Construct a Shift Reduce Parser for a given language.</li>
  <li>Write a program to perform loop unrolling.</li>
  <li>Write a program to perform constant propagation.</li>
  <li>Implement Intermediate code generation for simple expressions.</li>
  <li>Implement the back end of the compiler which takes the three address code and produces the 8086 assembly language instructions that can be assembled and run using an 8086 assembler. The target assembly instructions can be simple move, add, sub, jump etc.</li>
</ol>
